// uselist1.cpp  UNFINISHED
// Glenn G. Chappell
// 19 Nov 2013
//
// For CS 202 Fall 2013
// Simple main program for class template List1


#include "list1.h"  // For class template List1
#include <iostream>
using std::cout;
using std::endl;
using std::cin;
#include <stdexcept>
using std::out_of_range;


// printList1
// Print contents of list, front-to-back order, separated by blanks,
// followed by newline. For example, given a pointer to a List1<int>
// with 5 items:
//
// 1 5 -894 4 3
template<typename T>
void printList1(List1<T> * p)
{
    // WRITE THIS!!!
    cout << "[values in list go here]" << endl;  // Dummy print
}


// lookupList1
// Given pointer to List1, index, returns value at that index, or
// throws an exception of type out_of_range.
template<typename T>
T lookupList1(List1<T> * p, int index)
{
    if (index < 0)
        throw out_of_range("lookupList1: index too small");

    // WRITE THE REST OF THIS!!!
    // Note: index too *large* is not handled
    return T();  // Dummy return
}


// Main program
// Create a List1 Linked List, call functions printList1, lookupList1,
// and print the results, along with the expected results.
int main()
{
    // Create a Linked List
    List1<int> * p = new List1<int>(35);
    p = new List1<int>(23, p);
    p = new List1<int>(6, p);
    p = new List1<int>(1, p);
    p = new List1<int>(198, p);
    p = new List1<int>(-4, p);
    p = new List1<int>(0, p);
    p = new List1<int>(-18, p);
    p = new List1<int>(5, p);

    // Try function printList1
    cout << "Attempt to print list:" << endl;
    printList1(p);
    cout << "Above should have printed:" << endl;
    cout << "5 -18 0 -4 198 1 6 23 35" << endl;
    cout << endl;

    // Try function lookupList1
    cout << "Attempt to look-up item 0 of list:" << endl;
    try
    {
        cout << lookupList1(p, 0) << endl;
    }
    catch(out_of_range & e)
    {
        cout << "ERROR: " << e.what() << endl;
    }
    cout << "Above should have printed:" << endl;
    cout << "5" << endl;
    cout << endl;

    cout << "Attempt to look-up item 4 of list:" << endl;
    try
    {
        cout << lookupList1(p, 4) << endl;
    }
    catch(out_of_range & e)
    {
        cout << "ERROR: " << e.what() << endl;
    }
    cout << "Above should have printed:" << endl;
    cout << "198" << endl;
    cout << endl;

    cout << "Attempt to look-up item 99 of list:" << endl;
    try
    {
        cout << lookupList1(p, 99) << endl;
    }
    catch(out_of_range & e)
    {
        cout << "ERROR: " << e.what() << endl;
    }
    cout << "Above should have printed:" << endl;
    cout << "ERROR: [followed by an error message]" << endl;
    cout << endl;

    cout << "Press ENTER to quit ";
    while (cin.get() != '\n') ;

    return 0;
}

